%% PWASON TEST
clear all
close all
clc

%% Ex 1, Automatica, Nakada et al. 2005,
%Bemporad et al. 2003
%Ex 1, IEEE Tran Aut Ctrl., Bemporad et al. 2005
N=201;
u=rand(N,1)*8-4;
e=rand(N,1)*0.4-0.2;
y=zeros(1,N);
yt=zeros(1,N);
x=zeros(2,N);
theta=zeros(3,N);
ind=zeros(1,N);
figure
hold on

for k=2:N-1
    x(:,k)=[y(k-1) ; u(k-1)];
    if [4 -1]*x(:,k)<-10
        y(k)=[-0.4 1]*x(:,k)+1.5;
        ind(k)=1;
        theta(:,k)=[1.5; -0.4; 1];
        scatter(x(1,k),x(2,k),'b','filled')
    end
    if [-4 1]*x(:,k)<10 & [5 1]*x(:,k)<6
        y(k)=[-0.5 -1]*x(:,k)-0.5;
        ind(k)=2;
        theta(:,k)=[-0.5; -0.5; -1];
        scatter(x(1,k),x(2,k),'rx')
    end
    if [-5 -1]*x(:,k)<-6
        y(k)=[-0.3 0.5]*x(:,k)-1.7;
        ind(k)=3;
        theta(:,k)=[-1.7; -0.3; 0.5];
        scatter(x(1,k),x(2,k),'gs','filled')
    end
    yt(k)=y(k);
    y(k)=y(k)+e(k);
end
y=y(2:end);
x=x(:,2:end);
theta=theta(:,2:end);
yt=yt(2:end);


x2=-5:10:5;
x1=(-10+x2)/4;
plot(x1,x2,'--')
x1=(6-x2)/5;
plot(x1,x2,'--')

figure(2)
ti = -8:.5:8;
[XI,YI] = meshgrid(ti,ti);
ZI = griddata(x(1,:),x(2,:),yt,XI,YI);
mesh(XI,YI,ZI); hold on
plot3(x(1,:),x(2,:),y,'o')

%% PWASON
phi=[ones(1,size(x,2));x];
N=10;lambda=0.001;
[y_hat theta]=PWASON(phi',y,lambda,N);

%% 
N=200;
color={[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1],[1 0 0],[0 1 0],[0 0 1], [1 1 0], [0 1 1], [1 0 1]};
eps=2;
ind=zeros(N,1);
ind(1)=0;
figure(8)
hold on
m=1;
for k=1:N
    if ind(k)==0
        ind(k)=m;
        for t=k+1:N
            if (theta(:,k)-theta(:,t))'*(theta(:,k)-theta(:,t))<eps
                ind(t)=m;
            end
        end
        m=m+1;
        scatter(phi(2,ind==m-1), phi(3,ind==m-1),'o','MarkerFaceColor',color{m-1},'MarkerEdgeColor',[1 1 1]*0.1)
        hold on
    end
end

%% SVM -- one against the rest
for k=1:m-1
    ind_temp=zeros(size(ind'));
    ind_temp(ind==k)=-1;
    ind_temp(ind~=k)=1;
    C=10000;
    cvx_begin
    variables w(2,1) b(1,1) zeta(1,N)
    minimize (0.5*w'*w+C*ones(1,N)*zeta')
    subject to
    ind_temp.*(w'*phi(2:3,:)+b*ones(1,N))-ones(1,N)+zeta >= 0
    zeta >= 0
    cvx_end
    W(1:2,k)=-[b b]./w';
    figure(8)
    hold on
    xi = interp1([W(2,k) 0],[0 W(1,k)],[-4 4],'linear','extrap')
    plot(xi,[-4 4],'--k','linewidth',3)
end

